program compute_pi;

uses linux;

const NB=1001000;
      MAX=NB div 2;
      BASE=100;

type Tbig=array [1..MAX] of byte; (* X,XXXXXXX... *)

var deb:longint;

procedure big_add(var a:Tbig; b:Tbig); (* a:=a+b *)
var i,r,t:longint;
begin
  r:=0;
  for i:=MAX downto deb do begin
    t:=a[i]+b[i]+r;
    a[i]:=t mod BASE;
    r:=t div BASE;
  end;
end;

procedure big_mul(var a:Tbig; b:longint); (* a:=axb *)
var i,r,t:longint;
begin
  r:=0;
  for i:=MAX downto 1 do begin
    t:=a[i]*b+r;
    a[i]:=t mod BASE;
    r:=t div BASE;
  end;
end;

procedure big_div(var a:Tbig; b:longint); (* a:=a/b *)
var i,r,t:longint;
begin
  r:=0;
  for i:=1 to MAX do begin
    t:=r*BASE+a[i];
    a[i]:=t div b;
    r:=t mod b;
  end;
end;

procedure intro;
var time:longint;
begin
  writeln;
  writeln('Calcul de PI (c) Royale');
  writeln;
  time:=round(NB/500000*NB*0.41);
  writeln('Le calcul prendra environ : ');
  if time>24*60*60 then write(time div 24 div 60 div 60,' jour(s) ');
  time:=time-time div 24 div 60 div 60*24*60*60;
  if time>60*60 then write(time div 60 div 60,' heure(s) ');
  time:=time-time div 60 div 60*60*60;
  if time>60 then write(time div 60,' minute(s) ');
  time:=time-time div 60*60;
  writeln(time ,' seconde(s)...');
end;

var temp,pi:Tbig;
    n,i:longint;
    ok:boolean;

    fic:file of char;
    cc:char;

    total:longint;
    h,m,s,c:word;

begin

  intro;

  gettime(h,m,s,c);
  total:=c+100*(s+60*(m+60*h));

  for i:=1 to MAX do begin
    pi[i]:=0;
    temp[i]:=0;
  end;
  pi[1]:=3;
  temp[1]:=3;
  n:=0;
  deb:=1;
  repeat
    ok:=true;
    for i:=1 to 15 do if temp[deb+i]<>0 then ok:=false;
    if ok then inc(deb);
    inc(n);
    big_mul(temp,2*n-1);
    big_mul(temp,2*n-1);
    big_div(temp,8*n);
    big_div(temp,2*n+1);
    big_add(pi,temp);
  until n>NB*5/3;

  assign(fic,'pi.txt');
  rewrite(fic);
  cc:=chr(pi[1] mod 10+ord('0'));
  write(fic,cc);
  cc:=',';
  write(fic,cc);
  for i:=2 to MAX do begin
    cc:=chr(pi[i] div 10+ord('0'));
    write(fic,cc);
    cc:=chr(pi[i] mod 10+ord('0'));
    write(fic,cc);
  end;
  close(fic);

  gettime(h,m,s,c);
  total:=c+100*(s+60*(m+60*h))-total;
  writeln; writeln(total,' cs'); writeln;

end.
